package jemu.core.device.tape;


public class Array
{

    public Array()
    {
    }

    public static final String b2x(byte abyte0[])
    {
        StringBuffer stringbuffer = new StringBuffer(abyte0.length * 2);
        for(int i = 0; i < abyte0.length; i++)
        {
            stringbuffer.append(Character.forDigit(abyte0[i] >> 4 & 0xf, 16));
            stringbuffer.append(Character.forDigit(abyte0[i] & 0xf, 16));
        }

        return stringbuffer.toString().toUpperCase();
    }

    public static final int[] bytesToInts(byte abyte0[])
    {
        int ai[] = new int[abyte0.length];
        copy(abyte0, ai);
        return ai;
    }

    public static final void copy(byte abyte0[], int ai[])
    {
        if(abyte0.length != ai.length)
        {
            throw new ArrayIndexOutOfBoundsException("Source and target arrays are not of same size");
        }
        for(int i = 0; i < abyte0.length; i++)
        {
            ai[i] = abyte0[i] & 0xff;
        }

    }

    public static final void copy(int ai[], byte abyte0[])
    {
        if(ai.length != abyte0.length)
        {
            throw new ArrayIndexOutOfBoundsException("Source and target arrays are not of same size");
        }
        for(int i = 0; i < ai.length; i++)
        {
            abyte0[i] = (byte)ai[i];
        }

    }

    public static final String i2x(int i, int j)
    {
        return b2x(toBytesMsbf(i, j));
    }

    public static final byte[] intsToBytes(int ai[])
    {
        byte abyte0[] = new byte[ai.length];
        copy(ai, abyte0);
        return abyte0;
    }

    public static final byte[] subArray(byte abyte0[], int i, int j)
    {
        byte abyte1[] = new byte[j];
        System.arraycopy(abyte0, i, abyte1, 0, j);
        return abyte1;
    }

    public static final void toBytesLsbf(int i, byte abyte0[], int j, int k)
    {
        for(int l = j; l < j + k; l++)
        {
            abyte0[l] = (byte)i;
            i >>>= 8;
        }

    }

    public static final byte[] toBytesLsbf(int i, int j)
    {
        byte abyte0[] = new byte[j];
        toBytesLsbf(i, abyte0, 0, j);
        return abyte0;
    }

    public static final void toBytesMsbf(int i, byte abyte0[], int j, int k)
    {
        for(int l = (j + k) - 1; l >= j; l--)
        {
            abyte0[l] = (byte)i;
            i >>>= 8;
        }

    }

    public static final byte[] toBytesMsbf(int i, int j)
    {
        byte abyte0[] = new byte[j];
        toBytesMsbf(i, abyte0, 0, j);
        return abyte0;
    }

    public static final int toIntLsbf(byte abyte0[], int i, int j)
    {
        int k = 0;
        for(int l = (i + j) - 1; l >= i; l--)
        {
            k = k << 8 | abyte0[l] & 0xff;
        }

        return k;
    }

    public static final int toIntMsbf(byte abyte0[], int i, int j)
    {
        int k = 0;
        for(int l = i; l < i + j; l++)
        {
            k = k << 8 | abyte0[l] & 0xff;
        }

        return k;
    }

    public static final byte[] x2b(String s)
    {
        if(s.length() % 2 != 0)
        {
            throw new IllegalArgumentException("Hexadecimal string not even length");
        }
        byte abyte0[] = new byte[s.length() / 2];
        for(int i = 0; i < abyte0.length; i++)
        {
            abyte0[i] = (byte)(Character.getNumericValue(s.charAt(i * 2)) << 4);
            abyte0[i] |= (byte)Character.getNumericValue(s.charAt(i * 2 + 1));
        }

        return abyte0;
    }

    public static final int x2i(String s)
        throws NumberFormatException
    {
        return Integer.parseInt(s, 16);
    }
}
